/* -*- c++ -*-
   god.h

   General Operations Director

   perform operations requiring omnipotence in the simulation
   $Id: god.h,v 1.1.1.1 2000/08/28 18:40:06 jinyang Exp $
   */

#ifndef __god_h
#define __god_h

#include <stdarg.h>

#include <object.h>
#include <packet.h>
#include <trace.h>
#include <math.h>

#include <cmu/node.h>
#include <cmu/hgps/hdr_hgps.h>

class God : public Connector {
public:
        God();

        int             command(int argc, const char* const* argv);

        void            recv(Packet *p, Handler *h);
        void            stampPacket(Packet *p);

	//added by Jinyang
	bool		isAwake(nsaddr_t index);
	bool		isNeighbor(nsaddr_t src, nsaddr_t dst);

        int initialized() {
                return num_nodes && min_hops && target_;
        }

        int             hops(int i, int j);
        static God*     instance() { assert(instance_); return instance_; }

	MobileNode **nodelist; //added by Jinyang -- a reference to all the mobile nodes

#ifdef IDEAL_ROUTE
	bool		getRouteToLoc(nsaddr_t fromnode,location dstloc, nsaddr_t *route, int maxnodes);
	Quadtree        *root;
	Topography      *T;
#endif
	double *wakeup_list; //added by Jinyang -- take care of when each node has woken up

private:
        int num_nodes;
        int* min_hops;   // square array of num_nodesXnum_nodes
                         // min_hops[i * num_nodes + j] giving 
			 // minhops between i and j
	double *wakelist; //added by Jinyang -- take care of wake sleep scenarios
        static God*     instance_;

};

#endif
